lm.component('lmDialogFolderMount', {
	templateUrl: 'comp/dialog/lmDialogFolderMount.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($http, serviceLimboMedia, serviceNotification) {
		var ctrl = this;
		
		ctrl.name = '';
		ctrl.path = '';
		ctrl.browseFolder = null;
		
		ctrl.$onInit = function() {
			ctrl.browse('');
		}
		
		ctrl.browse = function(valuePath) {
			if(valuePath != null && valuePath != '') {
				ctrl.path = valuePath;
			}
			else {
				ctrl.path = '';
			}
			$http.get(lmBase.url + 'system/browseFolder',{params : {path:valuePath}}).then(
				function success(resp) {
					ctrl.browseFolder = resp.data;
					ctrl.name = resp.data.name;
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.save = function() {
			if(ctrl.path && ctrl.path != '') {
				var req = {parent: 0, name: ctrl.name, path: ctrl.path };
		
				$http.post(lmBase.url + 'f/folder',req).then(
					function success(resp) {
						serviceNotification.ok('MSG_JOB_STARTED');
						ctrl.lmDone();
					},
					serviceLimboMedia.handleHttpErrorNew
				);
			}
		};
		
	}
});
