/*
 * Params:
 * user: user to edit (required)
 */
lm.component('lmDialogUserEdit', {
	templateUrl: 'comp/dialog/lmDialogUserEdit.' + lmCacheTag + 'html',
	bindings: { lmParams: '<', lmDismiss: '&', lmDone: '&' },
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;

		ctrl.availableAuthorities = lmBase.authorities;
		ctrl.availableLanguages = [];
		
		ctrl.item = null;
		ctrl.authorities = [];

		ctrl.$onInit = function() {
			if(!ctrl.lmParams.user) {
				console.log("No user param. Closing.");
				ctrl.lmDismiss();
				return;
			}
			
			ctrl.item = ctrl.lmParams.user;
			lmBase.multiSelectionInit(ctrl.authorities,ctrl.availableAuthorities,ctrl.item.authorities);
			
			/* load available languages */
			$http.get(lmBase.url + 'system/info').then(
				function success(resp) {
					ctrl.availableLanguages = resp.data.languages;
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.ok = function() {
			var req = {name: ctrl.item.name, password: ctrl.item.password, language: ctrl.item.language, description: ctrl.item.description, enable: ctrl.item.enable}
			req.authorities = lmBase.multiSelectionGetSelected(ctrl.authorities);
			
			$http.post(lmBase.url + 'userAdmin/user/' + ctrl.item.id,req).then(
				function success(resp) {
					ctrl.lmDone();
				},
				serviceLimboMedia.handleHttpErrorNew
			);		
		};		
	
	}
});
