lm.component('lmFileImagebox', {
	templateUrl: 'comp/file/lmFileImagebox.' + lmCacheTag + 'html',
	bindings: {
		lmFiles: '<',
		lmFile: '<',
		lmWritable: '<',
		lmDone: '&'
	},
	controller: function($scope, $element, $animate, $http, $rootRouter, serviceLimboMedia, serviceFullscreen) {
		var ctrl = this;
		ctrl.fs = serviceFullscreen.state;
		
		ctrl.file = null;
		ctrl.idx = -1;
		
		ctrl.$onInit = function() {
			$element[0].addEventListener('click', ctrl.click);
		}

		ctrl.$onChanges = function(changesObj) {
			if(changesObj.lmFile) {
				if(changesObj.lmFile.currentValue) {
					ctrl.setFile(changesObj.lmFile.currentValue);
					$animate.removeClass($element, 'lmHide', { });
				}
				else {
					$animate.addClass($element, 'lmHide', { });
				}
			}
		}

		ctrl.setFile = function(valueFile) {
			ctrl.file = valueFile;
			ctrl.idx = ctrl.lmFiles ? ctrl.lmFiles.indexOf(valueFile) : -1;
		};

		ctrl.close = function() {
			if(serviceFullscreen.state.fullscreen) {
				serviceFullscreen.toggleFullscreen(false, $element[0]);
			}
			ctrl.lmDone();
		};

		ctrl.next = function() {
			for (i = parseInt(ctrl.idx) + 1; i < ctrl.lmFiles.length; i++) {
				var it = ctrl.lmFiles[i];
				if('IMAGE' == it.type) {
					ctrl.setFile(it);
					return;
				}
			}
			ctrl.close();
		};

		ctrl.prev = function() {
			for (i = parseInt(ctrl.idx) - 1; i >= 0; i--) {
				var it = ctrl.lmFiles[i];
				if('IMAGE' == it.type) {
					ctrl.setFile(it);
					return;
				}
			}
			ctrl.close();
		};

		ctrl.delete = function() {
			$http.delete(lmBase.url + 'f/file/' + ctrl.file.id).then(
				function success(resp) {
					var idx = ctrl.lmFiles.indexOf(ctrl.file);
					if(idx != -1) ctrl.lmFiles.splice(idx,1);

					if(ctrl.lmFiles.length > 0) {
						for (i = parseInt(ctrl.idx); i < ctrl.lmFiles.length; i++) {
							var it = ctrl.lmFiles[i];
							if('IMAGE' == it.type) {
								ctrl.setFile(it);
								return;
							}
						}
					}
					ctrl.close();
				},serviceLimboMedia.handleHttpErrorNew
			);
		};

		ctrl.click = function(evt) {
			var result = lmBase.mouseInElement(evt);
			$scope.$apply(function() {
				if(result < 0.33) ctrl.prev();
				else if(result > 0.66) ctrl.next();
				else ctrl.close();
			});
		};

		ctrl.fullscreen = function() {
			serviceFullscreen.toggleFullscreen(!serviceFullscreen.state.fullscreen, $element[0]);
		};
		
		ctrl.map = function(valueItem) {
			ctrl.close();
			$rootRouter.navigate(['AppMapFile', {fileId: ctrl.file.id}]);
		};
		

	}
});
