lm.component('homeBoxThings', {
	templateUrl: 'comp/homebox/homeBoxThings.' + lmCacheTag + 'html',
	bindings: {
		box: '<'
	},
	controller: function($http, serviceLimboMedia) {
		var ctrl = this;
		
		ctrl.error = null;
		ctrl.items = [];
		
		ctrl.loadItems = function() {
			$http.get(lmBase.url + 'iot/items',{params : {'hideOwn':ctrl.box.hideOwn, 'hideForeign':ctrl.box.hideForeign}}).then(
				function success(resp) {
					for(x in resp.data) {
						var it = resp.data[x];
						if(it.type == 'CONTROL_SELECT') {
							for(y in it.options) {
								var option = it.options[y];
								if(it.last && it.last.val == option.key) {
									it.selectedOption = option; 
								}
							}
						}
					}					
					ctrl.items = resp.data;
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.controlDoFire = function(con) {
			$http.post(lmBase.url + 'iot/item/' + con.id + '/control', {}).then(
				function success(resp) {
					serviceNotification.ok('DONE');
					con.last = resp.data;
				},
				serviceLimboMedia.handleHttpErrorNew
			);		
		};
		ctrl.controlDoSwitch = function(con, valOn) {
			var req = {val: valOn};
			$http.post(lmBase.url + 'iot/item/' + con.id + '/control', req).then(
				function success(resp) {
					con.last = resp.data;
				},
				serviceLimboMedia.handleHttpErrorNew
			);		
		};

		ctrl.controlDoSelect = function(con, valOn) {
			var req = {val: valOn.key};
			$http.post(lmBase.url + 'iot/item/' + con.id + '/control', req).then(
				function success(resp) {
					serviceNotification.ok('DONE');
					con.last = resp.data;
				},
				serviceLimboMedia.handleHttpErrorNew
			);		
		};

		ctrl.onPercentSliderChange = function(con, val) {
			var req = {'val': val};
			$http.post(lmBase.url + 'iot/item/' + con.id + '/control', req).then(
				function success(resp) {
					serviceNotification.ok('DONE');
					con.last = resp.data;
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		}
		
		ctrl.controlDoNumber = function(con) {
			if(!(con.last && con.last.val))
				return;
			
			var req = {val: con.last.val};
			$http.post(lmBase.url + 'iot/item/' + con.id + '/control', req).then(
				function success(resp) {
					serviceNotification.ok('DONE');
					con.last = resp.data;
				},
				serviceLimboMedia.handleHttpErrorNew
			);		
		};

		ctrl.controlDoString = function(con) {
			if(!(con.last && con.last.val))
				return;
			var req = {val: con.last.val};
			$http.post(lmBase.url + 'iot/item/' + con.id + '/control', req).then(
				function success(resp) {
					serviceNotification.ok('DONE');
					con.last = resp.data;
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.$onInit = function() {
			if(ctrl.box.type != 'thingsBox') return;
			ctrl.loadItems();
		};
		
	}
});