lm.component('pageSysLogs', {
  templateUrl: 'comp/page_sys/pageSysLogs.' + lmCacheTag + 'html',
  bindings: {
  },
  $canActivate: function($nextInstruction, $prevInstruction, serviceLimboMedia) {
	  return serviceLimboMedia.isAuthenticated();
  },
  controller: function($http, serviceLimboMedia, serviceNotification) {
	  var ctrl = this;
	  
	  ctrl.files = [];
	  ctrl.file = null;
	  ctrl.content = null;
		
	  ctrl.selections = [
	                     {name: "100 kb", value: 100000},
	                     {name: "1 mb", value: 1000000},
	                     {name: "10 mb", value: 10000000},
	                     {name: "unlimited", value: 0}
	                     ];
	  ctrl.selection = ctrl.selections[0];
		
	  ctrl.loadFiles = function() {
		  ctrl.file = null;
		  ctrl.files = [];
			
			$http.get(lmBase.url + 'logs/logfiles').then(
				function success(resp) {
					for(y in resp.data) {
						var it = resp.data[y];
						it.niceName = it.name + ' (' + lmBase.niceSize(it.size) + ')';
						ctrl.files.push(it);
						if(it.name == 'system.log') {
							ctrl.file = it;
						}
					}
					ctrl.loadFile();
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.loadFile = function() {
			if(ctrl.file == null || ctrl.selection == null) {
				ctrl.content = null;
				return;
			} 
			
			$http.get(lmBase.url + 'logs/logfile/' + ctrl.file.id + '/' + ctrl.selection.value).then(
				function success(resp) {
					ctrl.content = resp.data;
				},
				serviceLimboMedia.handleHttpErrorNew
			);
		};
		
		ctrl.loadFiles();
  }
});
