lm.directive('lmRole', function(serviceLimboMedia, $animate) {
	return {
	    restrict: 'A',
	    multiElement: true,
	    link: function(scope, element, attr) {
	    	scope.userdetails = serviceLimboMedia.userdetails;
	    	scope.$watch('userdetails.user', function(value) {
				var hasit = serviceLimboMedia.hasRole(attr.lmRole);
				$animate[hasit ? 'removeClass' : 'addClass'](element, 'lmHide', { });
				// TODO $animate ??? available ???
	    	});
	    }
	  };
});

lm.directive('lmShowIn', function(serviceLimboMedia, $animate) {
	return {
	    restrict: 'A',
	    multiElement: true,
	    link: function(scope, element, attr) {
	    	scope.userdetails = serviceLimboMedia.userdetails;
	    	scope.$watch('userdetails.user', function(value) {
				$animate[value ? 'removeClass' : 'addClass'](element, 'lmHide', { });
	    	});
	    }
	  };
});

lm.directive('lmHideIn', function(serviceLimboMedia, $animate) {
	return {
	    restrict: 'A',
	    multiElement: true,
	    link: function(scope, element, attr) {
	    	scope.userdetails = serviceLimboMedia.userdetails;
	    	scope.$watch('userdetails.user', function(value) {
				$animate[value ? 'addClass' : 'removeClass'](element, 'lmHide', { });
	    	});
	    }
	  };
});

lm.directive('lmSrc', function(serviceLimboMedia, $animate) {
	return {
	    restrict: 'A',
	    multiElement: true,
	    priority: 99,
	    link: function(scope, element, attr) {
	    	var loadImg = attr.lmLoader;
	    	var name = 'src';
	    	
	        attr.$observe('lmSrc', function(value) {
	            if (!value) {
	              return;
	            }
	            
	            if(!loadImg) {
	            	attr.$set(name,value);
	            }
	            else {
	            	attr.$set(name,loadImg);
		            var img = new Image();
		            img.src = value;
		            img.onload = function() {
		            	attr.$set(name,value);
		            };
	            }
	            
	            // Support: IE 9-11 only
	            // On IE, if "ng:src" directive declaration is used and "src" attribute doesn't exist
	            // then calling element.setAttribute('src', 'foo') doesn't do anything, so we need
	            // to set the property as well to achieve the desired effect.
	            // We use attr[attrName] value since $set can sanitize the url.
	            // if (msie && propName) element.prop(propName, attr[name]);
	          });
	    }
	
	  };
});

lm.directive('lmSensorgraph', function($http, serviceNotification) {
	
	function link(scope, element, attrs) {
		var sensordata;
	
		scope.$watch(attrs.lmSensorgraph, function(value) {
			sensordata = value;
			scope.drawFile();
      	});

		scope.drawFile = function() {
			if(sensordata == null) return;
			
			var sd = new Array();
			sd.push(sensordata);
			
			var graph = $.plot($(element), sd, {
				legend: {show:true, position:"ne",noColumns:1},
				lines: {show:true},
				xaxis: {
					mode: "time",
					timezone: "browser",
					timeformat: "%Y-%m-%d<br/>%H:%M:%S"
				},
				selection: { mode: "x" },
				tooltip: true,
				tooltipOpts: { content: "<h4>%s</h4> Value: %y.3<br/>%x" },
				grid: { hoverable: true }				
			});
		};
	};
    return { link: link };
});
